unit snd;

(********** ZVUKOVE PODPROGRAMY **********)
(********** (C) 1997 PEERSOFT   **********)
{Tyto podprogramy muzete vyuzit pro vytvareni zvukovych efektu pomoci
PC speakeru. Nektere tyto rutiny najdete i v unitu CRT,
ale tem se radeji vyhnete. Tento unit byste meli uvest
az za unitem CRT v klauzuli USES, aby se rutiny SOUND, DELAY a
NOSOUND prepsaly zde uvedenymi. Samozrejme muzete pouzit i samostatne.
Tento unit je vice nez dobrou nahrazkou CRT zvukovych rutin, protoze ty
se nedaji pouzit na masinach s rychlimi procesory. proto
dodavame tento unit jako FREEWARE.
}

interface
procedure sound(hz:word);
procedure delayc(ticks:word);
procedure nosound;
procedure chord(f1,f2,f3,f4,len:word);
procedure delay(ms:word);
procedure multichan(note1,note2:byte; totallen:word);
function freq2note(hz:word):byte;

implementation
uses dos;

var c1rate,c1roll,ticks18:word; {pro vnitrni potrebu}

{$F+}
procedure newint08; assembler;
asm
push ax
in al,61H
xor al,02H
out 61H,al
mov ax,c1rate
add c1roll,ax
adc ticks18,0
mov al,20H
out 20H,al
pop ax
iret
end;
{$F-}
procedure setc2(val:word); assembler;
{nastavi frekvenci kanalu 2}
asm
mov al,0B6H
out 43H,al
mov ax,val
out 42H,al
mov al,ah
out 42H,al
end;
procedure setc1(val:word); assembler;
{nastavi frekvenci kanalu 1}
asm
mov al,36H
out 43H,al
mov ax,val
mov bx,ax
shl ax,1
shl ax,1
shl ax,1
shr bx,1
shr bx,1
shr bx,1
shr bx,1
add ax,bx
shr ax,1
shr ax,1
shr ax,1
mov c1rate,ax
out 40H,al
mov al,ah
out 40H,al
end;
procedure sound;
{Zapina zvukovy generator na frekvenci HZ.}
begin
if hz<20 then exit;
setc2(1193180 div hz);
asm
in al,61h
or al,03H
out 61h,al
end;
end;

procedure delayc;
{Zpusobi casovou prodlevu po dobu TICKS tiku systemoveho
casovace. Jeden tik je priblizne osmnactina vteriny
(55 ms).}
var count:word;
tickc:longint;
timer:longint absolute $0000:$046C;
begin
count:=0;
tickc:=timer;
while count<ticks do begin
while tickc=timer do ;
inc(count);
tickc:=timer;
end;
end;
procedure nosound; assembler;
{Vypina zvukovy generator.}
asm
in al,61H
and al,0FCH
out 61H,al
end;

procedure chord;
{Zahraje akord o danem poctu milisekund. Prvni ctyri parametry
jsou frekvence tonu v HZ, paty parametr je delka v ms.
Pokud vas vicehlas ma mene nez 4 frekvence, za zbyvajici
dosadte nuly.}
var notelen:word;
fr:array[1..4] of word;
countfreq,loops,i:byte;
begin
if f1=0 then exit;
fr[1]:=f1;
fr[2]:=f2;
fr[3]:=f3;
fr[4]:=f4;
if f2=0 then countfreq:=1
else if f3=0 then countfreq:=2
else if f4=0 then countfreq:=3
else countfreq:=4;
notelen:=40;
loops:=len div (notelen * countfreq);
for loops:=loops downto 1 do
for i:=1 to countfreq do begin
sound(fr[i]);
delay(40);
end;
nosound;
end;

procedure delay(ms:word);assembler;
{Tato procedura zpusobi casovou prodlevu po dobu MS milisekund. Procedura
je jiz plne funkcni i na Pentiu.}
asm
mov ax,1000
mul ms
mov cx,dx
mov dx,ax
mov ax,8600H
int 15H
end;

procedure multichan;
{hraje dva kanaly najednou (ne jako CHORD)!
note1 a note2 jsou tony dvou hlasu, TOTALLEN je doba prehravani v MS.
Tony se zadavaji od nejnizsi oktavy jako pultony, takze C=0, C#=1, D=2 atd.
Poznamka: jestlize predtim hral nejaky ton, bude utnut.}

var tickval,value1,value2:word;
oldint08:procedure;
function makevalue(note:byte):word;assembler;
asm
jmp @@1
@freqtabl: dw 9120,8608,8124,7668,7238,6832,6448,6086,5746,5422,5118,4832
@@1:
push bx
push cx
mov ch,12
mov al,note
add al,ch
cbw
mov cl,ah
@@l01:
cmp al,ch
jb @@noadj
sub al,ch
inc cl
jmp @@l01
@@noadj:
shl ax,1
mov bx,ax
mov ax,word ptr @freqtabl[bx]
or cl,cl
jz @@noadjag
shr ax,cl
@@noadjag:
pop cx
pop bx
end;
begin
nosound;
value1:=makevalue(note1);
value2:=makevalue(note2);
getintvec($08,@oldint08);
setintvec($08,@newint08);
asm
push ax
push dx
in al,61H
or al,01H
out 61H,al
mov dx,03F2H
mov ax,0CH
out dx,al
pop dx
pop ax
end;
tickval:=totallen div 55;
if totallen mod 55<>0 then inc(tickval);
setc1(value2);
setc2(value1);
ticks18:=0;
while ticks18<tickval do ;
setintvec($08,@oldint08);
asm
push ax
mov al,36H
out 43H,al
xor al,al
out 40H,al
out 40H,al
in al,61H
and al,0FCH
out 61H,al
pop ax
end;
end;

function freq2note;
{Tato funkce se hodi pri pouzivani procedury MULTICHAN, ktera
vyzaduje hodnoty v pultonech. Pokud jste zvykli na zadavani frekvence
v HZ, pouzijte tuto funkci k prevedeni frekvence na pocet pultonu.
Poznamka: 131 je nejnizsi pouzivana frekvence v procedure MultiChan. Proto je-li frekvence
nizsi, upravi se na 131.}
var freq:real;
steps:byte;
begin
freq:=131.0;
if hz<131 then hz:=131;
steps:=0;
while freq<hz do begin
freq:=freq*exp(ln(2)/12);
inc(steps);
end;
freq2note:=steps;
end;
end.
